
fx_init	ldx #$00
	stx fx_set
	;
fx_set_ptr
	lda fx_ptr_lo,x
	sta fx_ptr
	lda fx_ptr_hi,x
	sta fx_ptr+1
	rts
	
next_byte	macro target_address
	lda (fx_ptr),y
	sta target_address
	iny
	endm 
	
fx_call	
	ldy #$00
	ldx fx_set
	beq fx_process
	;
	jsr fx_set_ptr
	sty fx_set
	;
fx_process
	lda (fx_ptr),y
	bmi fx_end
	;
	sta $FF11
	iny
	;
	next_byte F1LO
	lda F1HI
	and #$FC
	ora (fx_ptr),y
	sta F1HI
	iny
	next_byte F2LO
	next_byte F2HI
	;
	tya
	clc
	adc fx_ptr
	sta fx_ptr
	bcc *+4
	inc fx_ptr+1
	;
fx_end	rts

fx_ptr_lo
	db fx_no_data & 255
	db fx_data_1 & 255
	db fx_data_2 & 255
	db fx_data_3 & 255
	db fx_data_4 & 255
	db fx_data_5 & 255
	db fx_data_6 & 255

fx_ptr_hi
	db fx_no_data >> 8
	db fx_data_1 >> 8
	db fx_data_2 >> 8
	db fx_data_3 >> 8
	db fx_data_4 >> 8
	db fx_data_5 >> 8
	db fx_data_6 >> 8
	
C_0 = $0007
Ci0 = $0040
D_0 = $0076
Di0 = $00A9
E_0 = $00D9
F_0 = $0106
Fi0 = $0131
G_0 = $0159
Gi0 = $017F
A_0 = $01A3
Ai0 = $01C5
B_0 = $01E5
C_1 = $0204
Ci1 = $0220
D_1 = $023B
Di1 = $0254
E_1 = $026C
F_1 = $0283
Fi1 = $0298
G_1 = $02AD
Gi1 = $02C0
A_1 = $02D2
Ai1 = $02E3
B_1 = $02F3
C_2 = $0302
Ci2 = $0310
D_2 = $031E
Di2 = $032A
E_2 = $0336
F_2 = $0342
Fi2 = $034C
G_2 = $0356
Gi2 = $0360
A_2 = $0369
Ai2 = $0371
B_2 = $0379
C_3 = $0381
Ci3 = $0388
D_3 = $038F
Di3 = $0395
E_3 = $039B
F_3 = $03A1
Fi3 = $03A6
G_3 = $03AB
Gi3 = $03B0
A_3 = $03B4
Ai3 = $03B9
B_3 = $03BD
C_4 = $03C0
Ci4 = $03C4
D_4 = $03C7
Di4 = $03CB
E_4 = $03CE
F_4 = $03D0
Fi4 = $03D3
G_4 = $03D6
Gi4 = $03D8
A_4 = $03DA
Ai4 = $03DC
B_4 = $03DE
C_5 = $03E0
Ci5 = $03E2
D_5 = $03E4
OFF = $03FE

;> 6 klnbzo hangeffect kell.
;1. a mozgatshoz ,
;2. a szinlerakshoz ,
;3. a return megnyomsa ,
;4. a vgn megmutatja mi volt a helyes megolds ha nem tallja el jtkos a 4 szint , 
;5. ha kitallja a 4 szint s a 
;6. kilpshez a jtkbl.  A lny-eg ami eddig is a minl kisebb rasterido. A 4. hangeffect (mikor nem tallja ki a szineket) s az 5. hangeffect (mikor kita-
;> llja a
;> szineket)   3-4 msodperc hosszan  szljon. A tbbi 0.5 msodperc krli legyen.
;>

fx_data_1
	db $33
	dw C_2,C_1
	db $32
	dw C_3,C_1
	db $00, 0,0,0,0
	db $FF, $FF,$FF,$FF,$FF
	
fx_data_2
	db $16
	dw C_2,0
	db $15
	dw G_1,0
	db $14
	dw E_1,0
	db $12
	dw C_1,0
	db $00, 0,0,0,0
	db $FF, $FF,$FF,$FF,$FF
	
fx_data_3
	db $16
	dw C_1,0
	db $15
	dw G_0,0
	db $14
	dw E_0,0
	db $12
	dw C_0,0
	db $00, 0,0,0,0
	db $FF, $FF,$FF,$FF,$FF
	
fx_data_4
	db $34
	dw C_3+0, G_2+0
	db $38
	dw C_3+1, G_2+1
	db $37
	dw C_3+2, G_2+2
	db $37
	dw C_3+1, G_2+1
	db $36
	dw C_3+0, G_2+0
	db $36
	dw C_3-1, G_2-1
	db $35
	dw C_3-3, G_2-3
	db $35
	dw C_3-1, G_2-1
	db $34
	dw C_3+0, G_2+0
	db $34
	dw C_3+2, G_2+2
	db $34
	dw C_3+4, G_2+4
	db $34
	dw C_3+2, G_2+2
	;
	db $34
	dw B_2+0, Fi2+0
	db $38
	dw B_2+1, Fi2+1
	db $37
	dw B_2+2, Fi2+2
	db $37
	dw B_2+1, Fi2+1
	db $36
	dw B_2+0, Fi2+0
	db $36
	dw B_2-1, Fi2-1
	db $35
	dw B_2-3, Fi2-3
	db $35
	dw B_2-1, Fi2-1
	db $34
	dw B_2+0, Fi2+0
	db $34
	dw B_2+2, Fi2+2
	db $34
	dw B_2+4, Fi2+4
	db $34
	dw B_2+2, Fi2+2
	db $34
	dw B_2+0, Fi2+0
	;
	db $34
	dw Ai2+0, F_2+0
	db $38
	dw Ai2+1, F_2+1
	db $37
	dw Ai2+2, F_2+2
	db $37
	dw Ai2+1, F_2+1
	db $36
	dw Ai2+0, F_2+0
	db $36
	dw Ai2-1, F_2-1
	db $35
	dw Ai2-3, F_2-3
	db $35
	dw Ai2-1, F_2-1
	db $34
	dw Ai2+0, F_2+0
	db $34
	dw Ai2+2, F_2+2
	db $34
	dw Ai2+4, F_2+4
	db $34
	dw Ai2+2, F_2+2
	db $34
	dw Ai2+0, F_2+0
	db $33
	dw Ai2-2, F_2-2
	;
	db $34
	dw A_2+0, E_2+0
	db $38
	dw A_2+1, E_2+1
	db $37
	dw A_2+2, E_2+2
	db $37
	dw A_2+1, E_2+1
	db $36
	dw A_2+0, E_2+0
	db $36
	dw A_2-1, E_2-1
	db $35
	dw A_2-3, E_2-3
	db $35
	dw A_2-1, E_2-1
	db $34
	dw A_2+0, E_2+0
	db $34
	dw A_2+2, E_2+2
	db $34
	dw A_2+4, E_2+4
	db $34
	dw A_2+2, E_2+2
	db $33
	dw A_2+0, E_2+0
	db $33
	dw A_2-2, E_2-2
	db $33
	dw A_2-3, E_2-3
	db $32
	dw A_2-1, E_2-1
	db $32
	dw A_2+0, E_2+0
	db $32
	dw A_2+2, E_2+2
	db $31
	dw A_2+4, E_2+4
	db $31
	dw A_2+2, E_2+2
	db $31
	dw A_2+0, E_2+0
	
	db $00, 0,0,0,0
	db $FF, $FF,$FF,$FF,$FF

fx_data_5
	db $38
	dw C_1,G_1
	db $37
	dw C_2,G_2
	db $36
	dw C_3,G_3
	db $35
	dw C_1,G_1
	db $34
	dw C_2,G_2
	db $33
	dw C_3,G_3
	;
	db $38
	dw G_1,C_2
	db $37
	dw G_2,C_3
	db $36
	dw G_3,C_4
	db $35
	dw G_1,C_2
	db $34
	dw G_2,C_3
	db $33
	dw G_3,C_4
	;
	db $38
	dw C_2,E_2
	db $37
	dw C_3,E_3
	db $36
	dw C_4,E_4
	db $35
	dw C_2,E_2
	db $34
	dw C_3,E_3
	db $33
	dw C_4,E_4
	;
	db $38
	dw C_2,G_2
	db $37
	dw C_3,G_3
	db $36
	dw C_4,G_4
	db $35
	dw C_2,G_2
	db $34
	dw C_3,G_3
	db $33
	dw C_4,G_4
	;
	db $31
	dw C_2,G_2
	db $31
	dw C_3,G_3
	db $31
	dw C_4,G_4
	db $31
	dw C_2,G_2
	db $31
	dw C_3,G_3
	db $31
	dw C_4,G_4
	;
	db $38
	dw C_2,E_2
	db $37
	dw C_3,E_3
	db $36
	dw C_4,E_4
	db $35
	dw C_2,E_2
	db $34
	dw C_3,E_3
	db $33
	dw C_4,E_4
	;
	db $38
	dw C_2,G_2
	db $38
	dw C_3,G_3
	db $38
	dw C_4,G_4
	db $37
	dw C_2,G_2
	db $37
	dw C_3,G_3
	db $37
	dw C_4,G_4
	db $36
	dw C_2,G_2
	db $36
	dw C_3,G_3
	db $36
	dw C_4,G_4
	db $35
	dw C_2,G_2
	db $35
	dw C_3,G_3
	db $35
	dw C_4,G_4
	db $34
	dw C_2,G_2
	db $34 
	dw C_3,G_3
	db $34
	dw C_4,G_4
	db $33
	dw C_2,G_2
	db $33
	dw C_3,G_3
	db $33
	dw C_4,G_4
	db $32
	dw C_2,G_2
	db $32
	dw C_3,G_3
	db $32
	dw C_4,G_4
	db $31
	dw C_2,G_2
	db $31
	dw C_3,G_3
	db $31
	dw C_4,G_4
	
	db $00, 0,0,0,0
	db $FF, $FF,$FF,$FF,$FF
	
fx_data_6
	db $34
	dw D_3+0, G_0+0
	db $38
	dw E_3+1, G_0+2
	db $37
	dw E_3+2, G_0+4
	db $36
	dw E_3+1, G_0+2
	db $35
	dw E_3+0, G_0+0
	db $34
	dw E_3-1, G_0-2
	db $33
	dw E_3-2, G_0-4
	db $33
	dw E_3-1, G_0-2
	db $32
	dw E_3+0, G_0+0
	db $32
	dw E_3+1, G_0+2
	db $31
	dw E_3+2, G_0+4
	db $31
	dw E_3+1, G_0+2
	;
	db $34
	dw C_3+0, G_0+0
	db $38
	dw D_3+1, G_0+2
	db $37
	dw D_3+2, G_0+4
	db $36
	dw D_3+1, G_0+2
	db $35
	dw D_3+0, G_0+0
	db $34
	dw D_3-1, G_0-2
	db $33
	dw D_3-2, G_0-4
	db $33
	dw D_3-1, G_0-2
	db $32
	dw D_3+0, G_0+0
	db $32
	dw D_3+1, G_0+2
	db $31
	dw D_3+2, G_0+4
	db $31
	dw D_3+1, G_0+2
	db $31
	dw D_3+0, G_0+0
	db $31
	dw D_3-1, G_0-2
	db $31
	dw D_3-2, G_0-4
	db $31
	dw D_3-1, G_0-2
	db $31
	dw D_3+0, G_0+0
	db $31
	dw D_3+1, G_0+2
	db $31
	dw D_3+2, G_0+4
	db $31
	dw D_3+1, G_0+2
	db $31
	dw D_3+0, G_0+0
	db $31
	dw D_3-1, G_0-2
	db $31
	dw D_3-2, G_0-4
	db $31
	dw D_3-1, G_0-2
	;
	db $34
	dw D_3+0, B_0+0
	db $38
	dw E_3+1, B_0+2
	db $37
	dw E_3+2, B_0+4
	db $36
	dw E_3+1, B_0+2
	db $35
	dw E_3+0, B_0+0
	db $34
	dw E_3-1, B_0-2
	db $33
	dw E_3-2, B_0-4
	db $33
	dw E_3-1, B_0-2
	db $32
	dw E_3+0, B_0+0
	db $32
	dw E_3+1, B_0+2
	db $31
	dw E_3+2, B_0+4
	db $31
	dw E_3+1, B_0+2
	;
	db $34
	dw B_2+0, C_1+0
	db $38
	dw C_3+1, C_1+2
	db $37
	dw C_3+2, C_1+4
	db $36
	dw C_3+1, C_1+2
	db $35
	dw C_3+0, C_1+0
	db $34
	dw C_3-1, C_1-2
	db $33
	dw C_3-2, C_1-4
	db $33
	dw C_3-1, C_1-2
	db $32
	dw C_3+0, C_1+0
	db $32
	dw C_3+1, C_1+2
	db $31
	dw C_3+2, C_1+4
	db $31
	dw C_3+1, C_1+2
	db $31
	dw C_3+0, C_1+0
	db $31
	dw C_3-1, C_1-2
	db $31
	dw C_3-2, C_1-4
	db $31
	dw C_3-1, C_1-2
	db $31
	dw C_3+0, C_1+0
	db $31
	dw C_3+1, C_1+2
	db $31
	dw C_3+2, C_1+4
	db $31
	dw C_3+1, C_1+2
	db $31
	dw C_3+0, C_1+0
	db $31
	dw C_3-1, C_1-2
	db $31
	dw C_3-2, C_1-4
	db $31
	dw C_3-1, C_1-2
	;
	db $00, 0,0,0,0

fx_no_data
	db $FF, $FF,$FF,$FF,$FF
;eof		